=== dev/sample/hello_world/CMakeLists.txt ===
set(SAMPLE sample.hello_world)
include(${CMAKE_SOURCE_DIR}/cmake/sample.cmake)
