=== dev/sample/try_parse_query_string/CMakeLists.txt ===
set(SAMPLE sample.try_parse_query_string)
include(${CMAKE_SOURCE_DIR}/cmake/sample.cmake)
