=== dev/test/basic_auth/CMakeLists.txt ===
set(UNITTEST _unit.test.basic_auth)
include(${CMAKE_SOURCE_DIR}/cmake/unittest.cmake)
