=== dev/test/router/easy_parser_path_to_tuple/CMakeLists.txt ===
set(UNITTEST _unit.test.router.easy_parser_path_to_tuple)
include(${CMAKE_SOURCE_DIR}/cmake/unittest.cmake)
